%define im_dir %{_libdir}/im
%define letool %{_bindir}/iiimf-le-tools
%define sendhup /usr/bin/killall -HUP htt_server >& /dev/null || :
%define instle %{letool} --install %{im_dir}/leif/
%define uninstle %{letool} --remove %{im_dir}/leif/

Summary: An IIIMF Language Engine for Traditional Chinese.
Name: iiimf-le-xcin
Version: 0.1.7
Release: 13.EL4
License: GPL
Group: User Interface/X
Source0: %{name}-%{version}.tar.bz2
Patch0: iiimf-le-xcin-0.1.7-libdir.patch
Patch1: iiimf-le-xcin-0.1.7-backspaceafterlock.patch
Patch2: iiimf-le-xcin-0.1.7-malloc.patch
Patch3: iiimf-le-xcin-0.1.7-mem-event-status.patch
Patch4: iiimf-le-xcin-0.1.7-statusconv.patch
Patch5: iiimf-le-xcin-0.1.7-keylock.patch
Patch6: iiimf-le-xcin-0.1.7-preeditnokey.patch
Patch7: iiimf-le-xcin-0.1.7-punctuation.patch
Patch8: iiimf-le-xcin-0.1.7-ctrl.patch
Patch9: iiimf-le-xcin-0.1.7-LTC33720-3.patch
URL: http://tciiimf.sourceforge.net/

BuildRequires: automake16, libtool, libxml2-devel, pkgconfig
BuildRequires: XFree86-devel
Requires: iiimf-server >= 1:11.4-4
Buildroot: %{_tmppath}/%{name}-buildroot
Requires(post): %{_bindir}/killall
Requires(postun): %{_bindir}/killall

%description
A IIIMF language engine which ported from a popular traditional chinese input method, xcin, which was written using XIM protocol

%prep
%setup -q -n iiimf-xcin
%patch0 -p1 -b .libdir
%patch1 -p1 -b .backspace
%patch2 -p1 -b .malloc
%patch3 -p1 -b .20041015
%patch4 -p1 -b .conv
%patch5 -p1 -b .keylock
%patch6 -p1 -b .preeditnokey
%patch7 -p1 -b .punctuation
%patch8 -p1 -b .ctrl
%patch9 -p1 -b .ltc33720

find . -name CVS | xargs rm -rf
if [ %{im_dir} != "/usr/lib/im" ]; then
  find . -type f | xargs grep -l "/usr/lib/im" | \
        xargs perl -pi -e "s|/usr/lib/im|%{im_dir}|g;"
fi

%build
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./autogen.sh \
  --prefix=%{_prefix} 
make

%install
mkdir -p $RPM_BUILD_ROOT%{im_dir}/leif
mkdir -p $RPM_BUILD_ROOT%{im_dir}/locale/zh_TW/xcin/tab
make install DESTDIR=$RPM_BUILD_ROOT

%post
if [ -x %{letool} ]; then
  %{instle}xcin.so --default >& /dev/null || :
fi
%{sendhup}

%preun
if [ "$1" = 0 -a -x %{letool} ]; then
  %{uninstle}xcin.so >& /dev/null || :
fi

%postun
if [ "$1" = 0 ]; then
  %{sendhup}
fi

%files
%defattr(-,root,root)
%dir %{im_dir}/locale/zh_TW/
%dir %{im_dir}/locale/zh_TW/xcin/
%dir %{im_dir}/locale/zh_TW/xcin/tab/
%doc README ChangeLog 
%config %{im_dir}/locale/zh_TW/xcin/xcin.xml.conf
%{im_dir}/locale/zh_TW/xcin/*
%{im_dir}/leif/*

%clean 
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed Apr 18 2007 Caius Chance <cchance@redhat.com> - 0.1.7-13.EL4
- Resolves: rhbz#236085
- Fixed bz#236085: LTC33720-IIIMF disabled in Traditional Chinese for RHEL4U5.

* Wed Nov 23 2005 Leon Ho <llch@redhat.com> - 0.1.7-12
- Added patch to input Ctrl modified keys after activate (#161131)

* Tue Nov 16 2004 Leon Ho <llch@redhat.com> - 0.1.7-11
- fixed multibyte punctuation on input styles (#138959)

* Thu Nov 11 2004 Leon Ho <llch@redhat.com> - 0.1.7-10
- some inputsyles should not unlock candidate when backspacing (#136640)
- when preedit shouldn't pass space tab etc (#138799)

* Wed Oct 20 2004 Leon Ho <llch@redhat.com> - 0.1.7-9
- added to own %{im_dir}/locale/zh_TW/

* Fri Oct 15 2004 Leon Ho <llch@redhat.com> - 0.1.7-8
- fixed status conv for KDE 

* Fri Oct 15 2004 Leon Ho <llch@redhat.com> - 0.1.7-7
- fixed some more mem check errors
- fixed key events and status 
- removed iiimf-le-tools requires

* Wed Sep 29 2004 Leon Ho <llch@redhat.com> - 0.1.7-6
- fixes some malloc and fclose error
- fixes backspace problem after candidate lock

* Wed Sep 29 2004 Jens Petersen <petersen@redhat.com> - 0.1.7-5
- send hup to htt_server after removal not before
- add post, preun and postun requires for killall and iiimf-le-tools

* Mon Aug 30 2004 Leon Ho <llch@redhat.com> 0.1.7-4
- added %{im_dir}
- autogen call clean up
- added libdir patch

* Sun Aug 29 2004 Warren Togami <wtogami@redhat.com> 0.1.7-3
- minor spec cleanup

* Tue Aug 17 2004 Leon Ho <llch@redhat.com> 0.1.7-2
- add buildrequires on libxml2-devel, automake16 and libtool

* Mon Aug 16 2004 Leon Ho <llch@redhat.com> 0.1.7-1
- add xmlconf for tab files
- fixes more dynamic memory
- commented out source table for tab files
- added utf8 to utf16 function
- use cname in tab file if not specify in xml
- added new makefile.am and configure.ac for new xml and xml.conf

* Wed Aug 04 2004 Leon Ho <llch@redhat.com> 0.1-5-5
- backport from cvs
    - fixed non-reg key hold up problem (#127812)
    - added gen_inp_xim_end() and more free()s to resolve memory
    - resolved loadtab()'s malloc didn't free prob
    - added the call of gen_inp_xim_end() at DestorySC()
    - added arrow keys for changing candidate pages
    - added endkey feature which will lock in for the candidate
    - added check keyname so that it won't lock in if numeric
    - tidy up lookup_draw()

* Tue Jun 22 2004 Leon Ho <llch@redhat.com> 0.1-5-4
- backport from cvs
    - fixed no status window on conversion off
    - tidy up and seperate out sources
    - fix up some of the minor codings

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri May 21 2004 Leon Ho <llch@redhat.com> 0.1-5-2
- backport from cvs
    - fixed the problem on ctrl, alt keys when turned on (#121050)
    - added new candidate selection screen (shift+< and shift+>)

* Thu Apr 15 2004 Leon Ho <llch@redhat.com> 0.1.5-1
- iiimf-xcin 0.1.5
    - Included nine input methods
    - Use keyname instead of normal letters in preedit area
    - Fixed 'enter' should commit candidate when lookup is on
    - Fixed crash problem on running le couple of times
    - Fixed crash problem on loading input styles couple of times
    - Added ctrl-shift switching
    - Fixed the lookup window by closing it when switching

* Fri Feb 27 2004 Leon Ho <llch@redhat.com> 0.1-5
- rebuilt

* Thu Feb 26 2004 Leon Ho <llch@redhat.com> 0.1-4
- install cin2tab with 755 (#116892)
- install .so files with executable (#116554)
- fixed '0' commit to preedit problem
- added 'esc' clean preedit
- fixed candidates non-empty problems

* Thu Feb 16 2004 Leon Ho <llch@redhat.com> 0.1-3
- added cin2tab
- added conversion of cin to tab in compilation time

* Thu Feb 12 2004 Leon Ho <llch@redhat.com> 0.1-2
- fixed some multi candidates problem
- add tab file and change tab file locations

* Wed Feb 11 2004 Leon Ho <llch@redhat.com> 0.1-1
- iiimf-xcin v0.1

